import { S3Config } from '../utils/config';
import { NextApiRequest } from 'next';
import { NextRequest } from 'next/server';
type AppOrPagesRequest = NextApiRequest | NextRequest;
export type Options<R extends AppOrPagesRequest> = S3Config & {
    key?: (req: R, filename: string) => string | Promise<string>;
};
export declare function handler<R extends NextApiRequest | NextRequest>({ request, options, }: {
    request: R;
    options: Options<R>;
}): Promise<{
    key: string;
    bucket: string;
    region: string;
    endpoint: string | undefined;
    url: string;
    token?: undefined;
} | {
    token: import("@aws-sdk/client-sts").GetFederationTokenCommandOutput;
    key: string;
    bucket: string;
    region: string;
    endpoint?: undefined;
    url?: undefined;
}>;
export {};
