/// <reference types="react" />
type UploadResult = {
    url: string;
    bucket: string;
    key: string;
};
type RequestOptions = {
    url?: string;
    body?: Record<string, any>;
    headers?: HeadersInit;
};
type UploadToS3Options = {
    endpoint?: {
        request: RequestOptions;
    };
};
type OldOptions = {
    endpoint: string;
};
type Strategy = 'presigned' | 'aws-sdk';
export type Uploader<P = any> = (file: File, params: P, eventHandlers: {
    onProgress: (uploaded: number) => void;
}) => Promise<UploadResult>;
export declare const useUploader: (strategy: Strategy, uploader: Uploader, oldOptions?: OldOptions) => {
    FileInput: (props: any) => JSX.Element;
    openFileDialog: () => void;
    uploadToS3: (file: File, options?: UploadToS3Options) => Promise<UploadResult>;
    files: {
        file: File;
        progress: number;
        uploaded: number;
        size: number;
        id: string;
    }[];
    resetFiles: () => void;
};
export {};
